//go:build !purego

#include "textflag.h"

// validateByteArray is implemented in assembly because it is the bottleneck in
// many cases when encoding byte arrays. This version of the function yields
// ~50% better throughput than the code generated by the Go compiler.
//
// func validateByteArray([]byte) status
TEXT ·validateByteArray(SB), NOSPLIT, $0-32
    MOVQ arg_base+0(FP), AX
    MOVQ arg_len+8(FP), BX

    CMPQ BX, $0
    JE done

    CMPQ BX, $4
    JB errTooShort

    ADDQ AX, BX // end
loop:
    MOVL (AX), CX

    CMPL CX, $0x7FFFFFFF
    JA errTooLarge

    LEAQ 4(AX)(CX*1), AX
    CMPQ AX, BX
    JA errTooShort
    JB loop
done:
    XORQ AX, AX
return:
    MOVQ AX, ret+24(FP)
    RET
errTooShort:
    MOVQ $1, AX
    JMP return
errTooLarge:
    MOVQ $2, AX
    JMP return
